
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[译]函数式响应编程入门指南 / iVAN</title>

    <meta name="description" content="[译]函数式响应编程入门指南 本文讲的是[译]函数式响应编程入门指南, 原文地址:An Introduction to Functional Reactive Programming 原文作者:Daniel Lew 译文出自:掘金翻译计划 本文永久链接:github.com/xitu/gold-m- 译者:龙骑将杨影枫 校对者:jasonxia23.Tobias Lee 函数式响应编程入门指南 今年,我做了一场有关函数式响应编程(functional reactive programming,简称 FRP)的演讲,演讲的内容">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">[译]函数式响应编程入门指南</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>本文讲的是[译]函数式响应编程入门指南，</b></p>
<p><b><br /></b></p>
<blockquote><ul>
<li>原文地址：<a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2F2017%2F07%2F27%2Fan-introduction-to-functional-reactive-programming%2F" rel="external nofollow noreferrer">An Introduction to Functional Reactive Programming</a></li>
<li>原文作者：<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Fdlew" rel="external nofollow noreferrer">Daniel Lew</a></li>
<li>译文出自：<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Fxitu%2Fgold-miner" rel="external nofollow noreferrer">掘金翻译计划</a></li>
<li>本文永久链接：<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Fxitu%2Fgold-miner%2Fblob%2Fmaster%2FTODO%2Fan-introduction-to-functional-reactive-programming.md" rel="external nofollow noreferrer">github.com/xitu/gold-m…</a></li>
<li>译者：<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Fstormrabbit%2F" rel="external nofollow noreferrer">龙骑将杨影枫</a></li>
<li>校对者：<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Fjasonxia23" rel="external nofollow noreferrer">jasonxia23</a>、<a href="https://link.juejin.im/?target=https%3A%2F%2Fgithub.com%2Flileizhenshuai" rel="external nofollow noreferrer">Tobias Lee</a></li>
</ul>
</blockquote>
<h1>函数式响应编程入门指南</h1>
<p>今年，我做了一场有关函数式响应编程（functional reactive programming，简称 FRP）的演讲，演讲的内容包括“什么是函数式响应编程”以及“为什么你应该关注它”。这篇文章是演讲的文字版。</p>
<hr>
<h2>介绍</h2>
<p>函数式响应编程最近几年非常流行。但是它到底是什么呢？为什么你应该关注它呢？</p>
<p>即便是对于现在正在使用 FRP 框架的人 —— 比如 RxJava —— 来说，FRP 背后的基础理论还是很神秘的。今天我就来揭开这层神秘的面纱，将函数式响应编程分解成两个独立的概念：响应型编程和函数式编程。</p>
<h2>响应型编程</h2>
<p><a href="https://link.juejin.im/?target=https%3A%2F%2Fuser-gold-cdn.xitu.io%2F2017%2F8%2F18%2F7a7f759b845aa0ece73624e21b9bfa24" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvN2E3Zjc1OWI4NDVhYTBlY2U3MzYyNGUyMWI5YmZhMjQ/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />首先，让我们来看一下什么叫做响应型代码。</p>
<p>先从一个简单的例子开始：开关和灯泡。当有人拨动开关时，灯泡随之发亮或熄灭。</p>
<p>在编程术语中，这两个组件是耦合的。通常人们不太关心它们如何耦合，不过这次让我们深入研究一下。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide02.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNWY3NTE5NmNjNDY2YmZlZmUxODFkYjRkODRlMmRjNDY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />让灯泡随着开关发光或熄灭的方法之一，是让开关修改灯泡的状态。在这种情况下，开关是主动的，用新状态给灯泡赋值；灯泡是被动的，单纯地收到指令改变自己的状态。</p>
<p>我们在开关旁边画一个箭头来表示这种状态 —— 这就是说，连接两个组件的是开关，不是灯泡。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide03.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMTZkZWRjMjhlNDRlZDc4YWU0YWY1MGFkYWJmZWM5ZTY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />这是主动型解决方法的代码：开关类中持有一个灯泡类的实例化对象，通过修改实例对象来完成状态的修改。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide04.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNzc1YzNlMzBiNzUzZWM3ZTczODUxZDcwOTM0NmVhODc/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />另一种连接这两个组件的办法是让灯泡通过监听开关的状态来改变自己的值。在这种模型下，灯泡是响应型的，根据开关的状态修改自身的状态；开关是被观察者（observable），其他的观察者可以观察它的状态变化。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide05.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvOGRkNGUyMjRmNGJiOTRmZmQ4NDZiMjJlMmM3MGJlZjc/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />这是响应型解决方案的代码：灯泡 <code>LightBulb</code> 监听开关 <code>Switch</code> 的状态，根据开关状态改变的事件改变自身的状态。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide06.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvODU2ZTM2MjQxOTgxMmM0MzlmNGI4NjdkNWI0NWE4NDA/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />对终端用户来说，主动型和响应型编码结果是相同的。那么两者的差别在哪里呢？</p>
<p>第一个区别是，<code>灯泡</code>的控制者不同。在主动型模式中，是由另一个组件调用了灯泡对象的<code>LightBulb.power()</code> 方法。但是在响应型里，是由<code>灯泡</code>自己控制自己的亮度。</p>
<p>第二个区别是，谁决定了<code>开关</code>的控制对象。在主动型模式里，开关自己决定它控制谁。在响应式模式里，<code>开关</code>并不关心它控制谁，而其他组件只是在它身上挂了个监听器。</p>
<p>两者看起来好像是对方的镜像。两者间是二元对应的。</p>
<p>然而，正是这些微妙的差别造成了两个组件间是高耦合还是低耦合。在主动型模式中，组件互相直接控制。在响应型模式中，组件自己控制自己，互相之间没有直接交互。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide07.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZDc3ZDNiNThjZGZhYzA4YzQ1MTE4MTE5Zjc4MmFjOTA/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />举个现实中的例子：</p>
<p>这是 Trello 的主页面，它从数据库拿取图片数据并展示给用户。那么采用主动型的数据关系与响应型（的数据关系）有什么不同呢？</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide08.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZTYxZjZhZTA3NjYwMzJmMjI4MmYwNTFkMjYyYmQ5MWE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />如果是主动型模式，当数据库的数据更新时，数据库将最新的数据推送到用户界面。但是这种做法看起来毫无逻辑：为什么数据库需要关心用户界面？为什么要由数据库关心主页面到底展示了没有？为什么它要关心是否需要推送数据到主页面？主动型编码让数据库和用户界面之间缠缠绵绵，看起来好像是在做羞羞的事（creates a bizarrely tight coupling between my DB and my UI ）。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide09.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNDE2ODk1ODA0YTFhMzE5ZDYxNTQ2YjA4M2FkNzg2NzI/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />相对而言，响应型就简洁多了。用户界面监听数据库的数据变化，如果有需要的话就更新自己的界面。数据库就是一个傻乎乎的资源堆放地，顺便提供了一个监听器。任何组件都能读取到数据库的数据变化，而这些变化也很容易反应到需要的用户界面上。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide10.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvM2Q1ZWJlMDE5MjY4Mzg3MzlmNTRmNDliMzg3NmE3ZmY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />用一句好莱坞的拍戏信条概括就是：别给我们打电话，我们会打电话给你的（校对 Tobias Lee ：<em>don't call us, we'll call you</em> ，这个似乎是好莱坞演员面试的原则。是否被录用是由剧组决定的，演员不要主动打电话去询问）。这种形式会降低代码耦合度，允许攻城狮很好地封装组件。</p>
<p>现在我们可以回答什么是响应型编程了：那就是使用组件响应事件的编码形式，代替通常使用的主动型编码。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide11.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNWY2NTQ1ZjY2OWZiYzhkM2JjOGUzMGMwYWM3OGE4ZDY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />如果想经常使用响应型编码的话，简单的监听器还是不够完善。这样会产生一系列问题：</p>
<p>首先，每一个监听器都是独一无二的。我们有 <code>Switch.OnFlipListener</code> ，但是只能用来监听开关类 <code>Switch</code>。如果有多个被观察者，那每一个（被观察者）组件都需要实现（观察者）的监听接口。这不仅带来一系列无聊繁重的实现接口的工作，还意味着不能重复使用响应型编码的思维 —— 因为没有一个共同的架构来实现这种模式。</p>
<p>第二个问题是每一个观察者必须直接连接被观察的组件。<code>灯泡</code>对象必须直接和<code>开关</code>对象直连才能开始监听开关对象的状态。这其实是一个高耦合的编码形式，和我们的目标背道而驰。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide12.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZDAwMzU4ZmYzMjg1Yjc3YTZiYjM3MzUzYjcyMGRkODI/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />我们真正希望的是 <code>Switch.flips()</code> 返回一些可以被传递的泛型。来看看为了满足需求，我们应该选择哪种类型。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide13.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNGQyYzMxN2JmZmU3NDA4ZDRlNTNkYmY5MTU2ZWEwY2I/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />Java 函数可以返回四种基本对象。横轴代表需要返回值的数量：要么是一个，要么是多个。纵轴代表是否需要立刻（同步）返回还是需要延迟（异步）返回。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide14.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMDUyOTMxYzExOTRkYjU1YmUxMTlkNzFkNmI1OTJjNzI/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />同步的返回值很简单。如果是需要返回一个元素，那么可以用泛型 <code>T</code>。如果是需要多个返回值，可以用 <code>Iterable&lt;T&gt;</code>。</p>
<p>编写同步类型的代码比较简单，因为同步是所见即所用，但理论和现实还是有差距的。响应型编程天生具有异步属性：鬼知道被观察者什么时候会抽风个新状态出来。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide15.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMzQyZGYzNWQ1YTE5NzI4MzM1OTZiMmUxNmI3YzFlYWU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />这种情况下，我们需要研究一下异步返回值。如果需要一个返回值，可以用 <code>Future&lt;T&gt;</code>。看起来不错，但离需要的（类）还差点 —— 一个被观察者组件也许有很多返回值（比如说，<code>开关</code>对象就可能多次开开关关)。</p>
<p>我们真正需要的类在右下角，这块区域的类可以被称之为 <code>Observable&lt;T&gt;</code>。<code>Observable</code> 类是响应型框架的基础。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide16.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMzFkYzk4ZTJlMzg3MzAzNjRiM2IxZTljNjhlMjRhODk/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />来看看 <code>Observable&lt;T&gt;</code> 是如何起作用的。在上面的新代码里，<code>Switch.flips()</code> 返回一个<code>Observable&lt;Boolean&gt;</code> 对象 —— 换句话说，就是一系列 true 或则 false 的值，代表开关对象<code>Switch</code> 是处于打开状态还是处于关闭状态。灯泡对象 <code>LightBulb</code> 没有直接没有直接受制于<code>Switch</code> 对象，它只是订阅了由<code>开关</code>提供的 <code>Observable&lt;Boolean&gt;</code>。</p>
<p>这段代码和无 <code>Observable</code> 代码起着相同的作用，但是足以解决刚才我提到的两个问题。<code>Observable&lt;T&gt;</code> 是一个基础类型，在此基础之上可以进行更高层次的开发。而且它是可以被传递的，所以组件间的耦合度就降低了。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide17.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvODMxZjM2MDNkYzJjNWQzYmEwNjYwYWIwZThkMTZkZDU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />再巩固一下 <code>Observable</code> 是什么：一个 <code>Observable</code> 是一组随时间变化的元素集合。</p>
<p>用这张图来说明的话，横线代表时间，圈圈代表 <code>Observable</code> 发送给它的订阅者的事件。</p>
<p><code>Observable</code> 可以很好地表示两种可能的状态：成功还是报错。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide18.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMDk2ZmI1OTBjZThmNTNlNDM5MTQ5ZTljNGJjMTI1NTk/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />图中竖线代表一个成功的访问。并不是所有的集合都是无限的，所以有必要这么表示。比如说，如果你在 Netflix 上看视频的话，在特定的时候视频就会结束。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide19.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZTZmNjMzMTEyYmY4NzJlNjU5YmFkODU5MTYxNmFmMzU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />X 代表错误，即表示在结果流的数据在某个时候会变为非法值。比如说，如果莱因哈特对着开关就是一锤子，那么还是应该提醒用户：开关不仅没法产生任何新状态，甚至连开关自身都不可能再监听任何状态 — 因为它被砸坏了。</p>
<h2>函数式编程</h2>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide20.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMGNmNmU1MmRlNjNmODZhZWRhZjQ1YTc3Yjg3NDlkYWE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />让我们先把响应型编程放在一边，看看函数式编程是什么。</p>
<p>函数式编程的关键词是函数。嗯，对吧？我不准备讲什么普通的老式函数：我们现在研究的是纯函数。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide21.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvODUyNDJkMThiOTFkZTc2MTQxMzRmYjkwNWUzOGJkN2E/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />通过这个加法的例子来解释下什么是纯函数。</p>
<p>假设有一个完美的取两数之和的 <code>add()</code> 函数。等下，这个函数空缺的部分是啥？</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide22.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZWUyZDAzMmQ5OTM4YWE2NTQ0MzliZjQwZDcxNTczYWE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />哎呀，看起来 <code>add()</code> 函数把一些文字流输出到了控制台。这就是所谓的副作用。<code>add()</code> 的目的本不包括显示结果，仅做相加的动作。但是现在它修改了 app 全局的状态。</p>
<p>等下，还有更多。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide23.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMDhhYjc0MjBhYmEzMmFhOGM3YzBmMDIwZjk3NTU0NDQ/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />天啊，这回不光把数据输出到了控制台，连函数都强行结束了。如果单纯的看函数定义(两个参数，一个返回值)，谁也不知道这个函数会造成什么样的破坏。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide24.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNTQ5MGU0ODIwYTc1NDMyYjU5MWFmNGI0ODAwYjY4OTY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />再来看看另一个例子。</p>
<p>这次的例子是取一组数据，看看数据相加与数组相积是否一样。对数组 <code>[1, 2, 3]</code> 来说，这个结果应该是 true，因为不论相加还是相乘都是6。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide25.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNWE5OTRiNWI0MThlZGY0MTdlZjEyOTUzNGRkMzNkNWY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />然而，检查一下 <code>sum()</code> 方法是如何实现的。虽然没有修改 app 的全局状态，但是它改变了输入的参数！这意味着代码会失败，因为随着 <code>product(numbers)</code> 运行，<code>numbers</code> 最终会变成空集合的。这一系列的问题可能随时发生在真实的、不纯的函数中。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide26.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNTNlOTViMjI0ZTlkOTYwOWE5YTZhMDQ5YTdlY2U1Y2Y/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />任何改变函数额外状态的时候，都会产生副作用。如你所见，副作用会使得编码复杂化。纯函数不允许有任何的副作用。</p>
<p>有趣的是，这意味着纯函数必须有返回值。如果只有 <code>void</code> 的返回值，意味着纯函数啥都没做，因为它既没有改变输入值，也没有改变函数外的状态。</p>
<p>这同时意味着，函数的参数必须是不可变的(译者：比如用 final 修饰？)。不能允许参数可变，否则函数执行的时候有可能修改参数值，从而打破了纯函数的原则。顺便一提，这也暗示着输出值也必须是不可变的（不然的话输出值不能作为其他纯函数的参数）</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide27.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvYmNhMjg4MGY0YzEwZDlmOWI1ZTQ2NzViMmVjNTFiNTE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />有关纯函数的第二个方面，就是对于给定的输入值，纯函数必须返回相同的输出值。换句话说，纯函数不能依靠额外的状态。</p>
<p>比如说，检查一下这个欢迎用户的函数。虽然没有任何副作用，但是它随机返回两种欢迎语。这种随机性提供了一个额外的、静态的函数。</p>
<p>这使得编码从两方面来说更坑爹了。第一，函数的返回值和输入值没什么关系。如果知道相同的输入值可以产生相同的返回值，那么阅读代码会更不容易懵圈。第二，函数中有一个额外的依赖，如果该依赖产生了变化，那么函数的输出值也会改变。</p>
<p>面向对象的开发者很可能不理解，纯函数不能访问持有的类的状态。比如说，<code>Random</code> 的方法自带不纯属性，因为每次调用它都会返回不同的值。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide28.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvNmE3YzVmNzQ4ZmEwNWJhNGUyNGUyMDE4MWVjZWUzNzE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />简单的说：函数式编程依赖于纯函数。纯函数是不会消耗或者改变外部的状态 - 他们完全依赖输入值来产生输出值。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide29.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvY2EzMTgyZGZiYTk4Y2M5YzYwNDI1Nzc3MjkzZTU4MjY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />介绍函数式编程给大家时比较容易被混淆的是：(既然输入值是不可变的)，那如何让输出值有变化呢？比如说，如果我有一组整数，想获得以该组整数每个元素乘 2 的结果为新元素组成的数组。是不是必须改变列表的值呢？</p>
<p>嗯，其实不全是的。你可以使用纯函数改变列表。这是一个可以把集合里的值做 * 2 操作的纯函数。没有副作用，没有额外的状态，也没有改变输入值或者输出值。这个函数做了额外的修改状态的工作，所以你就不必这么做的。</p>
<p>然而，我们所写的这个方法扩展性太差了。它能做的只是把数组的每一个值都乘 2，但是如果想对数组的值进行其他操作呢？比如乘 3，除 2，想法是无穷无尽的。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide30.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvYTlhZmMxOTk3ODIzYTVjYzQ1ZmFmMzY1ZWRiZGNkNDU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />让我们写一个通用的整数数组计算器。首先写一个<code>函数式</code>接口，这样我们就可以定义如何计算每一个值。</p>
<p>然后写一个 <code>map()</code> 函数，此函数接受一个整数数组和一个 <code>Function</code>函数 做参数。对每一个数组的整数来说，都可以用 <code>Function</code> 计算。</p>
<p>赞美太阳！通过一点点额外的代码，我们可以对任何整数数组进行计算。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide31.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZWU3MzAwMzViOThlNTRlOWRhMjUzMmM2MjY0OWQyZTQ/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />我们甚至可以把这个例子拓展的更广泛一些：为什么不用一个更通用的类型，这样我们可以把任何列表转换为另一个其他的列表？只需要简单的修改一点刚才的代码。</p>
<p>现在，我们可以把任何 <code>List&lt;T&gt;</code> 转换为 <code>List&lt;R&gt;</code>。比如说，我们可以把一组字符串数组转换为一组每个字符串的长度的数组。</p>
<p><code>map()</code> 就是所谓的高阶函数，因为它的参数之一也是函数。能够传递并且使用函数做参数是一个很牛逼的做法，因为它允许代码变的更灵活。不必再写反复的、实例化的函数，可以使用泛型度更高的函数比如 <code>map()</code> 来处理具有共性的逻辑。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide-31.2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMzk1YzU3ZTdmNDU1ZGI5NWZhNjgzNTQ1Zjk3ZWY4OWI/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />除了能更轻松的处理一系列额外的状态之外，纯函数还可以更容易组织函数。如果有一个 <code>A -&gt; B</code> 的函数，又有一个 <code>B -&gt; C</code> 的函数，我们可以把两个函数结合起来，以产生 <code>A -&gt; C</code>。</p>
<p>当你可以组织不纯函数时，总是会发生意料之外的副作用，这意味着组织函数是否正确的执行是个未知数。只有纯函数可以保证组织起来的代码是安全的。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide-31.3.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZmM4ZjBjZDIzNWQwYjdhYzc2MTI5ZjZlMjFiOTljZDQ/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />再举个栗子。这是另一个简单的函数式编程的函数 —— <code>filter()</code>。<code>filter()</code> 可以帮助我们过滤集合中的元素。现在我们可以在转换集合之前，先进行过滤操作。</p>
<p>现在我们有了一对很小但是很勥的转换函数。它们的强力值随着允许我们自有组装函数而变的越来越大。</p>
<p>其实函数式编程比我提到的还要多，但是现在讲述的东西足够我们明白函数式响应编程里的函数式了。</p>
<h2>函数式响应编程</h2>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide32.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZTZjNzNkMjBmZjBlYmQwMjcxODI2ZTZlYzJiMzQyY2Y/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />现在可以解释什么是函数式响应编程了。</p>
<p>还是以开关类 <code>Switch</code> 举例，这次我们不提供 <code>Observable&lt;Boolean&gt;</code> 类，我们提供一个基于自身状态枚举流的 <code>Observable&lt;State&gt;</code>。</p>
<p>看起来我们没办法把开关和灯泡关联在一起，因为我们的泛型不相容。但是还有一个明显的方式让 <code>Observable&lt;State&gt;</code> 酷似<br /><code>Observable&lt;Boolean&gt;</code> —— 如果可以把一种流转换为另一种呢？</p>
<p>还记得之前函数式编程里的 <code>map()</code> 函数吗？该函数将一个同步集合转换为另一个。我们能否用相同的思想来把一个异步集合转换为另一个呢？</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide33.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZmZjZjczMDRmMGE2MjY3ZGEzODE5MjQwOTNkOGE5Yjg/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />啦啦啦：这就是 <code>map()</code>，但是是用来转换 <code>Observable</code>的。<code>Observable.map()</code> 就是所谓的操作符（operator）。操作符允许攻城狮把任一 <code>Observable</code> 转换成基本上其他能所想到的类。</p>
<p>操作符的图表画起来比之前见到的要麻烦。让我们来把它弄清楚：</p>
<p>上面的代表输入流：一系列的有颜色的圈圈。</p>
<p>中间的代表一系列操作符：把一个圈圈转换为方块。</p>
<p>下面的那行代表着输出流：一系列有颜色的方块。</p>
<p>本质上，在输入流里做的是 1:1 的转换。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide34.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZWYxOTM1MDM0M2NjZGM4NDgzNTRiNjhhYjcxNzMwNGY/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />还是以开关的例子来说明。先写一个 <code>Observable&lt;State&gt;</code> ，然后使用 <code>map()</code> 操作符（对<code>Observable&lt;State&gt;</code> 进行转换），这样每次产生新 <code>状态</code> 的时候，操作符 <code>map()</code> 返回一个<code>Observable&lt;Boolean&gt;</code> 对象。现在我们有了正确的返回类型，就可以构造<code>灯泡</code>对象<code>LightBulb</code>了。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide-34.2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvYjdmZGY2NjZiOGFlNGNlMWQ2NTZjOWJlYzQ0M2IyZmE/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />好吧，这很有用。但是为什么一定要用纯函数呢？为什么不能随便在 <code>map()</code> 写一点？为什么引起副作用就有问题呢？当然，可以这么做，但是马上就会让代码很难处理。再说，这么做会错过不少不允许副作用的操作符。</p>
<p>假设 <code>State</code> 的枚举类型有两种以上的状态，但是用户只关心打开或者关闭。如果这样的话，我们要过滤掉其他的状态。看，这里有一个 <code>filter()</code> 的操作符。还可以用 <code>map()</code> 来获得想要的结果。</p>
<p>将函数式响应编程的代码和之前的函数式代码相比较，你会发现两者非常相似。唯一的区别就是函数式编程的代码处理的是同步的集合，函数式响应编程处理的是异步集合。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide35.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvZjgwNDkyNTExM2RkNGM2Njk0ZDUwMTVjYjBhMGMyZGU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />函数式响应编程的代码有一大堆操作符，可以把常见的问题转换成对流的控制，而流最大的好处就是可以多次组装。举一个真实的例子：</p>
<p>我之前展示的 Trello 主屏幕很简单 —— 它只有一个从数据库到用户界面的大箭头。但事实上，主屏幕用的数据源还有很多。</p>
<p>事实上，每一个数据源的数据可能有很多的展示位置。我们必须保证同步接收资源，否则可能会出现数据匹配错误，造成展示位置没有对应的数据源的 bug。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide36.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvMWRmNjI5NmM2MTZmNGJjYmYyN2I4MDJjODMwZGQzYzQ/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />我们使用 <code>combineLatest()</code> 避免这种问题，<code>combineLatest()</code> 接收复数的数据流并且将他们组合成一个数据流。这么做有什么好处呢？每次任何一个输入流改变的时候，它也跟着改变，这样就可以保证发送给 UI 的数据包是完整的了。</p>
<p><a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2Fcontent%2Fimages%2F2017%2F07%2Fslide37.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3VzZXItZ29sZC1jZG4ueGl0dS5pby8yMDE3LzgvMTgvYjQ5NzE0YWYyNDA5YjhiYmIxMTBhMjZjMzVmYTUxZDU/aW1hZ2VWaWV3Mi8wL3cvMTI4MC9oLzk2MC9pZ25vcmUtZXJyb3IvMQ==.jpg"></a><br />
<br />函数式响应编程中有很多有价值的操作符，这里只给大家看一些简单的…… 多数情况下，第一次使用函数式响应编程的攻城狮看到一大堆操作符都会晕过去。</p>
<p>然而，这些操作符的目标并不是让人崩溃 —— 它们为了组织典型的数据。它们是你的朋友，不是敌人。</p>
<p>我建议大家可以一步一步的接受他们。并不需要马上记住所有的操作符；相反，只需要记住当前应该使用什么操作符。需要的时候去查询一下，然后经过一系列训练你就会习惯它们的。</p>
<h2>额外的东西</h2>
<p>我试图去回答“什么是函数式响应编程”。现在我们有了答案：所谓函数式响应编程，就是响应型数据流与函数式操作符的组合。</p>
<p>但是为什么要尝试使用函数式响应编程呢？</p>
<p>响应型数据流允许你通过标准方法编写组件间的模块化编码。响应型数据可以帮助攻城狮对组件进行解耦。</p>
<p>响应型数据流天生自带异步属性。也许你的工作是同步的，但是大部分我编写的 app 都是基于异步的用户输入和操作。使用一个基于异步编写的框架比自己摸索着写代码的方式要简单的多。</p>
<p>函数式响应型编码的函数式部分可以给予攻城狮使用可靠的方法操作数据流的工具，因而特别有用。 函数式操作符允许攻城狮控制数据流之间的交互，同时可以编写可复用的代码模块来应对有共性的逻辑。</p>
<p>函数式响应编程不够直观。大部分人开始编程的时候都是使用非纯的函数或者主动的方式，包括我。也许你使用这种方式的时间太久了，而这种方式也深深的印在了你的脑子里，以至于你认为这种方式是唯一的解决方式。如果能够打破这种惯性思维，你可以编写出更多高质量的代码。</p>
<h2>引用</h2>
<p>感谢在以下资料对我演讲的帮助：</p>
<ul>
<li><a href="https://link.juejin.im/?target=https%3A%2F%2Fcycle.js.org%2Fstreams.html" rel="external nofollow noreferrer">cycle.js 对主动型与响应型编码的解释（cycle.js has a great explanation of proactive vs. reactive code）</a>，我参考了它的文档来筹备演讲。</li>
<li><a href="https://link.juejin.im/?target=https%3A%2F%2Fchannel9.msdn.com%2FEvents%2FLang-NEXT%2FLang-NEXT-2014%2FKeynote-Duality" rel="external nofollow noreferrer">Erik Meijer 做了一场碉堡了的、有关响应型/主动型二元对应的演讲</a>，我从中借鉴了 4 项函数式的基本效果。本演讲有点高深，但是如果你能吃透它，它非常有启发性。</li>
<li>如果读者希望了解更多有关函数式编程的东西，我推荐大家使用一门函数式编程语言。Haskell 就特别不错，因为它严格使用函数式编程的规范，意味着你不能使用作弊的方式学习。<a href="https://link.juejin.im/?target=http%3A%2F%2Flearnyouahaskell.com%2F" rel="external nofollow noreferrer">"Learn you a Haskell" 是一部优秀而且免费的在线书籍</a>，想跟深入研究得人可以看一看。</li>
<li>如果想学习更多函数式响应编程的姿势，欢迎阅读<a href="https://link.juejin.im/?target=http%3A%2F%2Fblog.danlew.net%2F2014%2F09%2F15%2Fgrokking-rxjava-part-1%2F" rel="external nofollow noreferrer">我的博客上的一系列文章</a>。此演讲中所阐述的知识点和博客上的文章有交叉，但是博客上的文章会更多的阐述使用 RxJava 的细节。</li>
</ul>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b><br /></b></p>
<p><b>原文发布时间为：2017年8月18日</b></p>
<p><b><br /></b></p>
<p><b>本文来自合作伙伴掘金，了解相关信息可以关注掘金网站。</b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 22:50:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b/" title="编程">编程</a>, <a href="https://www.iamivan.net/tag/%e7%94%a8%e6%88%b7%e7%95%8c%e9%9d%a2/" title="用户界面">用户界面</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e6%b5%81/" title="数据流">数据流</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>[译]函数式响应编程入门指南的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL3W3M.html" rel="bookmark">Apache Camel的Java编程入门指南&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 Apache Camel是一个非常实用的规则引擎库,能够用来处理来自于不同源的事件和信息.你可以在使用不同的协议比如VM,HTTP,FTP,JMS甚至是文件系统中来传递消息,并且让你的操作逻辑和传递逻辑保持分离,这能够让你更专注于消息的内容. 在这篇文章中,我将提供一个Java语言(非Groovy)的Apache Camel入门演示. 首先创建一个Maven项目的pom.xml.   &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk01Y7z.html" rel="bookmark">Python的设计模式编程入门指南&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有没有想过设计模式到底是什么?通过本文可以看到设计模式为什么这么重要,通过几个Python的示例展示为什么需要设计模式,以及如何使用.设计模式是什么? 设计模式是经过总结.优化的,对我们经常会碰到的一些编程问题的可重用解决方案.一个设计模式并不像一个类或一个库那样能够直接作用于我们的代码.反之,设计模式更为高级,它是一种必须在特定情形下实现的一种方法模板.设计模式不会绑定具体的编程语言.一个好的设计模式应该能够用大部分编程语言实现(如果做不到全部的话,具体取决于语言特性).最为重要的是,设计模式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn0qvob.html" rel="bookmark">《Visual Basic 2012入门经典》---- 2&period;7 快速而简单的编程入门指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.7 快速而简单的编程入门指南 Visual Basic 2012入门经典编程很复杂.所有东西都互相关联,因此很难将每个编程概念分开然后用线性方式加以说明.相反,在学习一个主题的过程中,通常在学到另一个主题前就需要接触它.正如第1章指出的,我尽量避免这种前向参考,但有些概念需要你首先熟悉一下.这些主题在对应的章节中都将介绍,但阅读本书之前你必须至少听说过. 2.7.1 用变量存储值 变量是代码中用于保存值的元素.例如,可以创建一个保存用户名或用户年龄的变量.每个变量(存储实体)都必须在使用前创			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdyY4M.html" rel="bookmark">比较不错的函数式JavaScript编程指南教程&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你是否知道JavaScript其实也是一个函数式编程语言呢?本指南将教你如何利用JavaScript的函数式特性. 要求:你应当已经对JavaScript和DOM有了一个基本的了解. 写这篇指南的目的是因为关于JavaScript编程的资料太多了但是极少的资料提到了JavaScript的函数式特性.在本指南中,我只会讲解这些基本知识而不会深入其它的函数式语言或这是Lambda算子. 你可以点击所有的例子然后你所看到的代码就会被执行,这样就可以令指南变得具有交互性.你也可以使用这个沙箱来尝试. 第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PB2Bp.html" rel="bookmark">&lbrack;译&rsqb; iOS 响应式编程：Swift 中的轻量级状态容器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] iOS 响应式编程:Swift 中的轻量级状态容器, 原文地址:Reactive iOS Programming: Lightweight State Containers in Swift 原文作者:Tyler Tillage 译文出自:掘金翻译计划 本文永久链接:github.com/xitu/gold-m- 译者:deepmissea 校对者:FlyOceanFish iOS 响应式编程:Swift 中的轻量级状态容器 事物的状态 在客户端架构如何工作上,每一个 iOS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Ya8Zz.html" rel="bookmark">《C语言编程初学者指南》一第1章　C编程入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 C编程入门 C语言编程初学者指南 欢迎阅读本书.C 编程语言是培养你的编程职业技能和爱好的一门优秀的基础语言.不管你是计算机专业的学生.自学成才的程序员,或者是一名资深的软件工程师,学习C语言都能够给你丰富的概念知识并培养实践技能,从而很好地帮助你理解其他的计算机相关主题(包括操作系统概念.内存管理和其他高级的编程语言). 在整个本书中,我将引导你学习一系列的示例,这些示例设计来讲解C编程的基础知识.我假设读者没有C编程的经验,也不了解计算机科学的基本概念.阅读本书不需要任何的经验(包括			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjEDKM.html" rel="bookmark">Google自动编程框架AutoML入门指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Google自动编程框架AutoML入门指南, 前言 本篇是和Kabuto_hui(ISN国家重点实验室成员)合作修改生成的,感谢Kabuto_hui. 导读 Google在AI First的战略下,陆续发布AI相关的产品,技术.据最新的报道:Google AutoML 系统自主编写机器学习代码,其效率在某种程度上竟然超过了专业的研发工程师.AutoML的目标并不是要将人类从开发过程中剥离出去,也不是要开发全新的人工智能,而是让人工智能继续维持某种速度来改变世界.笔者认为,机器编程即将			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyWWOlz.html" rel="bookmark">函数式JavaScript编程指南&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 你是否知道JavaScript其实也是一个函数式编程语言呢?本指南将教你如何利用JavaScript的函数式特性.  要求:你应当已经对JavaScript和DOM有了一个基本的了解. 写这篇指南的目的是因为关于JavaScript编程的资料太多了但是极少的资料提到了JavaScript的函数式特性.在本指南中,我只会讲解这些基本知识而不会深入其它的函数式语言或这是Lambda算子.  你可以点击所有的例子然后你所看到的代码就会被执行,这样就可以令指南变得具有交互性.你也可以使用这个沙箱来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Q63aM.html" rel="bookmark">JavaScript的函数式编程基础指南&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 JavaScript是一种强大的,却被误解的编程语言.一些人喜欢说它是一个面向对象的编程语言,或者它是一个函数式编程语言.另外一些人喜欢说,它不是一个面向对象的编程语言,或者它不是一个函数式编程语言.还有人认为它兼具面向对象语言和函数式语言的特点,或者,认为它既不是面向对象的也不是函数式的,好吧,让我们先搁置那些争论. 让我们假设我们共有这样的一个使命:在JavaScript语言所允许的范围内,尽可能多的使用函数式编程的原则来编写程序. 首先,我们需要清理下脑子里那些关于函数式编程的错误观			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVNXQz.html" rel="bookmark" class="title">上传图片-图片上传过程和下载过程的问题</a>
					<div>
						问题描述 图片上传过程和下载过程的问题 从客户端上传图片给服务器这个过程中图片是被压缩后上传还是直接原图?一般从服务器下载的图片会比当初自己上传的照片小很多这个是不是在下载的过程中被处理了还是说服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPxxAp.html" rel="bookmark" class="title">Photoshop制作精致的金色木柄放大镜</a>
					<div>
						教程难点是镜框及手柄部分的制作.镜框部分稍微复杂一点,有金属框和玻璃,需要分开完成.手柄部分需要用滤镜等做出木质纹理,然后调色,增加高光及暗部即可. 最终效果 1.新建一个1000 * 700像素,分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYQD9M.html" rel="bookmark" class="title">JSP应用语法详解大全&lpar;一&rpar;</a>
					<div>
						js|详解|语法 1)HTML注释:可以用注释内容,也可以用表达式.2)隐藏注释:注释会被JSP编译时被忽略.编译器不会对之间的语句编译,它不会显示在客户的浏览器和源代码中. 3)声明:声明你将要在J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAjDvp.html" rel="bookmark" class="title">谷歌推出蜂鸟算法 庆祝15周岁生日</a>
					<div>
						谷歌庆祝15周岁生日 谷歌搜索发展历程 为了庆祝15周岁的生日,谷歌周四在当年创业的车库里举行了一次发布会,推出了全新的&quot;蜂鸟&quot;(Hummingbird)算法,能够以更加人性化的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrJlvM.html" rel="bookmark" class="title">高权重问答平台分析</a>
					<div>
						做网络推广,高权重的问答推广平台不失为一个好的方法途径,高权重的问答平台的特点我想大家也都知道,收录快,排名好,可以给网站传递一定的权重和流量,好好利用好高权重的问答平台,会让你得到意想不到的结果!下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9oXkz.html" rel="bookmark" class="title">怎么样写一段高效，安全的sql查询代码---（很基础，但是大家很容易忽略的）</a>
					<div>
						安全 看一看这段代码,让我们来看看主要存在的问题 //设置SQL语句            insertstr=&quot;insert into userinfo(name,password,ema ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boV0Ez.html" rel="bookmark" class="title">OSPF精髓5类LSA和RIP综合实验</a>
					<div>
						R1的配置:首先配置每个接口ip地址 并加上环回口 R1&gt;en R1#conf t R1(config)#inter fa0/0   R1(config-if)#ip address 202.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlEQ5b.html" rel="bookmark" class="title">从业务视角看交互设计师的价值</a>
					<div>
						  最近和组里的设计师review近期工作进展时,发现了不少问题.想起设计新人一脸无辜和迷茫的表情,我觉得我需要再多做点什么.对于处在业务部门中的UED团队来说,专业固然重要,但更重要的是如何体现你带 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlREjqz.html" rel="bookmark" class="title">Photoshop给水岸边的人物加上唯美的秋季淡蓝色</a>
					<div>
						  素材图片颜色有点杂乱,人物部分不够突出.处理的时候先把主色调成较为统一的蓝色,树叶部分的颜色转为淡黄色;然后给高光区域增加淡蓝色,暗部增加蓝色,并加强好局部明暗即可. 原图 最终效果 1.打开原图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYRwOb.html" rel="bookmark" class="title">pdf转换成word在线转换器网站</a>
					<div>
						  迅捷在线pdf转换器是由迅捷工作室针对个别用户所特别研发的一款在线PDF转换工具,完全免费.无需注册.不限使用次数,无需下载安装即可转换文件,非常的方便.迅捷在线PDF转换器目前有四种转换模式,包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamm4wb.html" rel="bookmark" class="title">创建和使用 WebAssembly 组件</a>
					<div>
						本文讲的是创建和使用 WebAssembly 组件, 原文地址:Creating and working with WebAssembly modules 原文作者:本文已获作者 Lin Clark  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrnEVM.html" rel="bookmark" class="title">专访新智元AI年度人物周志华：不负责任的夸大渲染是人工智能最大阻碍</a>
					<div>
						新智元2016中国人工智能年度人物评选昨晚22时公布投票结果.南京大学教授周志华以55票的得票数当选年度学术人物,得票率高达48%.  新智元2016中国人工智能年度人物的评选由新智元于12月底在新智 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QlvJp.html" rel="bookmark" class="title">人类河流文明 - 数据的流动与生态的重要性</a>
					<div>
						背景 人类社会文明源起于河流文化,人类社会发展积淀河流文化,河流文化生命推动社会发展. 河流文化作为一种人类的文化.文明类型,被人们认知已经经历了很长的历史时期,人们把其称为&quot;大河文明&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxomVmb.html" rel="bookmark" class="title">java、api-如何获得其他网页的pm2&period;5的数据传到自己数据库中，有相关api接口，可不会用</a>
					<div>
						问题描述 如何获得其他网页的pm2.5的数据传到自己数据库中,有相关api接口,可不会用 如何获得其他网页的pm2.5的数据传到自己数据库中,有相关api接口,可不会用 解决方案 有相关接口那就很简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmWDWz.html" rel="bookmark" class="title">FFmpeg实现监控摄像头的RTSP协议转RTMP协议直播</a>
					<div>
						文章来源:http://www.cuplayer.com/player/PlayerCode/RTSP/2014/0706/1419.html     FFmpeg实现监控摄像头的RTSP协议转RTM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQkyqp.html" rel="bookmark" class="title">我国光伏市场发展现状深度分析</a>
					<div>
						随着环境保护理念的深入和化石燃料价格的波动,我国出台了一系列政策支持光伏行业发展,为光伏爆发式增长提供了政策托底.在政府大力扶持之下,2015年我国光伏产业在低迷能源市场中&quot;起死回生&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWgg6p.html" rel="bookmark" class="title">更改web&period;xml默认欢迎页面。</a>
					<div>
						转载文章,参考地址如下: http://simen-net.iteye.com/blog/1489928 默认web.xml欢迎页面为index.html 我给更改为: &lt;welcome-fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBrEoM.html" rel="bookmark" class="title">华为员工家属：华为人收入高背后是全家人的付出</a>
					<div>
						华为人的工资看上去很高.实际上,这收入背后不仅是他一个人的奉献,更是全家人的付出.就算年薪百万以上者有万余人,那也只占到华为17万员工的近6%. &quot;华为&quot;成为媒体热词.&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKWVNb.html" rel="bookmark" class="title">大数据征信：央行开了&OpenCurlyDoubleQuote;半扇门&rdquo;</a>
					<div>
						在1月5日,中国人民银行官网发布消息称,人民银行已印发&lt;关于做好个人征信业务准备工作的通知&gt;,要求芝麻信用管理有限公司等八家机构做好个人征信业务的准备工作,准备时间为六个月. 这是2013 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD9mKz.html" rel="bookmark" class="title">ios-请IOS大神指教。。。Orz</a>
					<div>
						问题描述 请IOS大神指教...Orz 为什么老是报错这个实例啊,求解决方法 解决方案 对象初始化的方法不对吧. 解决方案二: 是不是context是nil啊?报错信息太少 无法做出准确判断					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmK1vM.html" rel="bookmark" class="title">手机日期插件jquery mobiscroll 实例</a>
					<div>
						net视图引擎可直接渲染mobiscroll控件   @using (Html.BeginForm())   {       @Html.LabelFor(m =&gt; m.Name)        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKxE3b.html" rel="bookmark" class="title">&period;xin 域名信用验证问题集锦</a>
					<div>
						1..xin 域名为什么要进行信用验证?     .xin域名是阿里巴巴推出的首个新顶级域,音同&quot;信&quot;,让用户信赖的域名! 欲通过互联网的入口,联合各诚信评价机构(包括阿里巴巴企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgrRob.html" rel="bookmark" class="title">myecplise debug用不了</a>
					<div>
						问题描述 myecplisedebug模式启动就报FATALERRORinnativemethod:JDWPNotransportsinitialized,jvmtiError=AGENT_ERROR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw40mM.html" rel="bookmark" class="title">PS中常用的快捷键汇总介绍</a>
					<div>
						一.辅助线和标尺快捷键 注意:辅助线是通过从标尺中拖出而建立的,所以要确保标尺是打开的[Ctrl+R] ( View &gt; Show Rulers ). 拖动辅助线时按住Shift键将强制其对齐到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgemJM.html" rel="bookmark" class="title">运维请注意：&rdquo;非常危险&OpenCurlyDoubleQuote;的Linux命令大全</a>
					<div>
						Linux命令是一种很有趣且有用的东西,但在你不知道会带来什么后果的时候,它又会显得非常危险.所以,在输入某些命令前,请多多检查再敲回车. rm –rf rm –rf是删除文件夹和里面附带内容的一种最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeY58M.html" rel="bookmark" class="title">怎么把SqlSever的存储过程改成MySql的存储过程 谁帮忙看下，我改了半天没出来。</a>
					<div>
						问题描述 修改前(SQLSVEVER的):createPROCEDURE[dbo].[QueryPagedData](@TableNameVARCHAR(200),----待查询表名@TableCol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZaqEp.html" rel="bookmark" class="title">《Python数据科学指南》&mdash;&mdash;1&period;9　生成一个迭代器和生成器</a>
					<div>
						1.9 生成一个迭代器和生成器 上一节,我们了解了什么是迭代器,这一节我们来讨论如何生成一个迭代器. 1.9.1 准备工作 生成器提供了清晰的语法,能够依次访问一个序列,并不需要使用__iter__和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2wx5z.html" rel="bookmark" class="title">用Python编写一个简单的Lisp解释器的教程&lowbar;python</a>
					<div>
						本文有两个目的: 一是讲述实现计算机语言解释器的通用方法,另外一点,着重展示如何使用Python来实现Lisp方言Scheme的一个子集.我将我的解释器称之为Lispy (lis.py).几年前,我介 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWVqaz.html" rel="bookmark" class="title">Ajax上传图片的本质&lowbar;AJAX相关</a>
					<div>
						1.图片上传到服务器. 2.后台将图片地址传到html页面,以图片形式展现. 3.后天将图片地址加入到input表单中,表单处于隐藏状态. 4.前端删除图片,通过js操作,移除图片与表单数据. 5.图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7007M.html" rel="bookmark" class="title">Apache Rewrite实现URL的301跳转和域名跳转&lowbar;Linux</a>
					<div>
						如果要想用到rewrite模块,必须先安装或加载rewrite模块.方法有两种一种是编译apache的时候就直接安装rewrite模块,别一种是编译apache时以DSO模式安装apache,然后再利 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.045 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
